Attribute VB_Name = "ParameterCommon"
'  FILE:       ParameterCommon.bas
'              Microsoft TPC-H Kit Ver. 2.7.0-1005
'              Copyright Microsoft, 2008
'              All Rights Reserved
'
'
'  PURPOSE:    Contains functionality common across StepMaster and
'              SMRunOnly, pertaining to parameters
'              Specifically, functions to load parameter records
'              in an array.
'  Contact:    Reshma Tharamal (reshmat@microsoft.com)
'
Option Explicit

' Used to indicate the source module name when errors
' are raised by this module
Private Const mstrModuleName As String = "ParameterCommon."

Public Sub LoadRecordsetInParameterArray(rstWorkSpaceParameters As Recordset, _
    cParamCol As cArrParameters)

    Dim cNewParameter As cParameter
    
    On Error GoTo LoadRecordsetInParameterArrayErr

    If rstWorkSpaceParameters.RecordCount = 0 Then
        Exit Sub
    End If
   
    rstWorkSpaceParameters.MoveFirst
    While Not rstWorkSpaceParameters.EOF
    
        Set cNewParameter = New cParameter
        
        ' Initialize parameter values
        cNewParameter.ParameterId = rstWorkSpaceParameters.Fields(0)
        
        ' Call a procedure to raise an error if mandatory fields are
        ' null.
        cNewParameter.ParameterName = CStr( _
                ErrorOnNullField(rstWorkSpaceParameters, "parameter_name"))
        cNewParameter.ParameterValue = CheckForNullField( _
                rstWorkSpaceParameters, "parameter_value")
        cNewParameter.WorkspaceId = CStr( _
                ErrorOnNullField(rstWorkSpaceParameters, FLD_ID_WORKSPACE))
        cNewParameter.ParameterType = CStr( _
                ErrorOnNullField(rstWorkSpaceParameters, "parameter_type"))
        cNewParameter.Description = CheckForNullField( _
                rstWorkSpaceParameters, "description")

        cParamCol.Load cNewParameter
        
        Set cNewParameter = Nothing
        rstWorkSpaceParameters.MoveNext
    Wend
    
    Exit Sub
    
LoadRecordsetInParameterArrayErr:
    LogErrors Errors
    gstrSource = mstrModuleName & "LoadRecordsetInParameterArray"
    On Error GoTo 0
    Err.Raise vbObjectError + errLoadRsInArrayFailed, gstrSource, _
            LoadResString(errLoadRsInArrayFailed)
End Sub
